//  Pac Man I
//
//  Copyright (c) Cyrion Software
//  All Rights Reserved
//
//  +-- misc.cc -----------------------------------------------------------+
//
//  Last Updated: 11 of April of 1999 <rp>
//  Tools       : DJGPP v2 + Allegro 3.1 + RHIDE 1.4
//  Target      : DOS v5.0+

                                                // declarao de header files
#include "pacgame.h"


Button *btn_start_game;
Button *btn_custom_game;
Button *btn_prev_menu;
Button *btn_high_scores;
Button *btn_credits;
Button *btn_options;


/* +--------------------------------------------------------- Options ---+
   | Verso   : I (1.00.00)                                              |
   | Funo   : Opes                                                   |
   +---------------------------------------------------------------------+ */

void Options(void)
{
  PlaySong();                                         // toca msica de fundo
  fade_out(10);
  char *dif_levels[] = {                               // dificuldade de jogo
    "Easy",                                                          // fcil
    "Normal",                                                       // normal
    "Hard"                                                         // difcil
  };
  Button btn_exit_options = Button("E x i t", 215, 400, 425, 430, 28, 20, (BITMAP*)graphics[BTN_GAME].dat);
  if (sound_on)                                                  // se h som
    strcpy(text, "Sound On");
  else                                                       // se no h som
    strcpy(text, "Sound Off");
  Button btn_sound_on = Button(text, 80, 100, 290, 130, 28, 20, (BITMAP*)graphics[BTN_GAME].dat);
  if (music_on)                                      // se h msica de fundo
    strcpy(text, "Music On");
  else                                           // se no h msica de fundo
    strcpy(text, "Music Off");
  Button btn_music_on = Button(text, 350, 100, 560, 130,28, 20, (BITMAP*)graphics[BTN_GAME].dat);
  Button btn_sound_rt = Button(NULL, 80, 200, 110, 230, 28, 20, (BITMAP*)graphics[BTN_LEFT].dat);
  Button btn_sound_lt = Button(NULL, 260, 200, 290, 230, 28, 20,(BITMAP*)graphics[BTN_RGHT].dat);
  Button btn_music_rt = Button(NULL, 350, 200, 380, 230, 28, 20, (BITMAP*)graphics[BTN_LEFT].dat);
  Button btn_music_lt = Button(NULL, 530, 200, 560, 230, 28, 20,(BITMAP*)graphics[BTN_RGHT].dat);
  Button btn_dif_rt = Button(NULL, 215, 300, 245, 330, 28, 20, (BITMAP*)graphics[BTN_LEFT].dat);
  Button btn_dif_lt = Button(NULL, 395, 300, 425, 330, 28, 20, (BITMAP*)graphics[BTN_RGHT].dat);

  sprintf(text, "%d", sound_volume);
  Button btn_sound_volume = Button(text, 111, 200, 259, 230, 28,20, (BITMAP*)graphics[BTN_GAME].dat);
  sprintf(text, "%d", music_volume);
  Button btn_music_volume = Button(text, 381, 200, 529, 230, 28, 20, (BITMAP*)graphics[BTN_GAME].dat);
  Button btn_dif_level = Button(dif_levels[dif_level], 246, 300, 394, 330, 28,20, (BITMAP*)graphics[BTN_GAME].dat);

  show_mouse(NULL);                                         // esconde o rato
  clear(screen);
  drawing_mode(DRAW_MODE_COPY_PATTERN, (BITMAP*)graphics[PATTERN2].dat, 0, 0);
  rectfill(screen, 0, 0, SCREEN_W, SCREEN_H, 1);
  solid_mode();
  text_mode(-1);
  rect(screen, 0, 0, SCREEN_W-1, SCREEN_H-1, 25);
  textout_centre(screen, (FONT*)graphics[FONT_GAME].dat, "O P T I O N S", SCREEN_W/2, 20, 15);
  textout_centre(screen, (FONT*)graphics[FONT_GAME].dat, "Sound Volume", 195, 160, 15);
  textout_centre(screen, (FONT*)graphics[FONT_GAME].dat, "Music Volume", 455, 160, 15);
  textout_centre(screen, (FONT*)graphics[FONT_GAME].dat, "Difficulty level", SCREEN_W/2, 260, 15);
  show_mouse(screen);                                        // mostra o rato
  btn_exit_options.DrawButton();                         // desenha os botes
  btn_sound_on.DrawButton();
  btn_music_on.DrawButton();
  btn_sound_rt.DrawButton();
  btn_sound_lt.DrawButton();
  btn_music_rt.DrawButton();
  btn_music_lt.DrawButton();
  btn_dif_rt.DrawButton();
  btn_dif_lt.DrawButton();
  btn_music_volume.DrawButton();
  btn_sound_volume.DrawButton();
  btn_dif_level.DrawButton();
  show_mouse(NULL);                                         // esconde o rato
  fade_in((RGB*)graphics[PAL_EDIT].dat, 5);
  show_mouse(screen);                                        // mostra o rato
  while (1==1) {
    if (btn_exit_options.Clicked())                                // E x i t
      break;
    else
      if (btn_sound_on.Clicked()) {                                  // Sound
        if (sound_on) {                                          // se h som
          sound_on = FALSE;                                      // desliga-o
          btn_sound_on.ChangeName("Sound Off");
          btn_sound_on.DrawButton();
        }
        else {                                               // se no h som
          sound_on = TRUE;                                          // liga-o
          btn_sound_on.ChangeName("Sound On");
          btn_sound_on.DrawButton();
        }
      }
      else
        if (btn_music_on.Clicked()) {                                // Music
          if (music_on) {                            // se h msica de fundo
            music_on = FALSE;                                    // desliga-a
            stop_midi();                            // para a msica de fundo
            btn_music_on.ChangeName("Music Off");
            btn_music_on.DrawButton();
          }
          else {                                 // se no h msica de fundo
            music_on = TRUE;                                        // liga-a
            PlaySong();                               // toca msica de fundo
            btn_music_on.ChangeName("Music On");
            btn_music_on.DrawButton();
          }
        }
        else
          if (btn_sound_lt.Clicked()) {                           // + volume
            if (sound_volume < 250) {
              sound_volume += 10;
              sprintf(text, "%d", sound_volume);
              btn_sound_volume.ChangeName(text);
              btn_sound_volume.DrawButton();
              set_volume(sound_volume, music_volume);
            }
          }
          else
            if (btn_sound_rt.Clicked()) {                         // - volume
              if (sound_volume > 0) {
                sound_volume-=10;
                sprintf(text, "%d", sound_volume);
                btn_sound_volume.ChangeName(text);
                btn_sound_volume.DrawButton();
                set_volume(sound_volume, music_volume);
              }
            }
            else
              if (btn_music_lt.Clicked()) {                       // + volume
        	if (music_volume < 250) {
                  music_volume += 10;
                  sprintf(text, "%d", music_volume);
                  btn_music_volume.ChangeName(text);
                  btn_music_volume.DrawButton();
                  set_volume(sound_volume, music_volume);
                }
              }
              else
                if (btn_music_rt.Clicked()) {                     // - volume
                  if (music_volume > 0) {
                    music_volume -= 10;
                    sprintf(text, "%d", music_volume);
                    btn_music_volume.ChangeName(text);
                    btn_music_volume.DrawButton();
                    set_volume(sound_volume, music_volume);
                  }
                }
                else
                  if (btn_dif_lt.Clicked()) {                // + dificuldade
                    if (dif_level < 2) {
                      dif_level++;
                      btn_dif_level.ChangeName(dif_levels[dif_level]);
                      btn_dif_level.DrawButton();
                    }
                  }
                  else
                    if (btn_dif_rt.Clicked()) {              // - dificuldade
                      if (dif_level > 0) {
                        dif_level--;
                        btn_dif_level.ChangeName(dif_levels[dif_level]);
                        btn_dif_level.DrawButton();
                      }
                    }
  }
  fade_out(10);
  stop_midi();                                        // para msica de fundo
}

/* +-------------------------------------------------- fim de Options ---+ */

/* +----------------------------------------------------- ViewCredits ---+
   | Verso   : I (1.00.00)                                              |
   | Funo   : Mostra os crditos do jogo                               |
   +---------------------------------------------------------------------+ */

void ViewCredits(void)
{
  #define MAX_LINES  30                          // mximo de linhas a exibir
  char *credits[] = {                                       // texto a exibir
    "Pac Man I",
    "",
    "Programming",
      "Ricardo Pereira",
    "",
    "Graphics",
      "Ricardo Pereira",
      "Tnia Pinho",
    "",
    "Level Design",
      "Ricardo Pereira",
      "Tnia Pinho",
    "",
    "Music",
      "Ricardo Pereira",
    "",
    "Sounds",
      "Tnia Pinho",
    "",
    "Tester",
      "Tnia Pinho",
    "",
    "",
    "",
    "Pac Man I was produced by",
    "Cyrion Software",
    "with",
    "DJGPP v2",
    "Allegro v3.1",
    "Rhide v1.4",
  };

  int position = SCREEN_H;
  PlaySong();                                         // toca msica de fundo
  show_mouse(NULL);                                         // esconde o rato
  fade_out(255);
  set_pallete((RGB*)graphics[PAL_TITLE2].dat);
  blit((BITMAP*)graphics[GTITLE].dat, screen, 0, 0, 0, 0, 640, 480);
  fade_in((RGB*)graphics[PAL_TITLE2].dat, 5);
  text_mode(-1);
  clear_keybuf();                                // limpa o buffer do teclado
  while (1==1) {
    blit((BITMAP*)graphics[GTITLE].dat, screen_bitmap, 0, 0, 0, 0, 640, 480);
    for (int i = 0; i < MAX_LINES; i++)
    textout_centre(screen_bitmap, (FONT*)graphics[FONT_NORMAL].dat, credits[i], SCREEN_W/2,position+i*20,255);
    vsync();
    vsync();
    blit(screen_bitmap, screen, 0, 0, 0, 0, 640,480);
    position -= 1;
    if (position + MAX_LINES * 20 < 0)
      position = SCREEN_H;
    if (keypressed())                // se qualquer tecla for pressionada sai
      break;
  }
  stop_midi();                                        // para msica de fundo
  fade_out(2);
  clear(screen);
}

/* +---------------------------------------------- fim de ViewCredits ---+ */

/* +-------------------------------------------------- DrawHighScores ---+
   | Verso   : I (1.00.00)                                              |
   | Funo   : Desenha o cran                                          |
   +---------------------------------------------------------------------+ */

void DrawHighScores()
{
  show_mouse(NULL);                                         // esconde o rato
  clear(screen);
  drawing_mode(DRAW_MODE_COPY_PATTERN, (BITMAP*)graphics[PATTERN2].dat, 0, 0);
  rectfill(screen, 0, 0, SCREEN_W, SCREEN_H, 1);
  solid_mode();
  text_mode(-1);
  rect(screen, 0, 0, SCREEN_W-1, SCREEN_H-1, 25);

  textout_centre(screen, (FONT*)graphics[FONT_GAME].dat, "H I G H   S C O R E S",SCREEN_W/2, 20, 15);
  textout(screen, (FONT*)graphics[FONT_NORMAL].dat, "Name", 150, 60, 15);
  textout(screen, (FONT*)graphics[FONT_NORMAL].dat, "Score", 380, 60, 15);
  textout(screen, (FONT*)graphics[FONT_NORMAL].dat, "Level", 450, 60, 15);
  for (int i = 0; i < MAX_HIGHSCORES; i++) {
    sprintf(text, "%2d     %s", i+1, HighScores[i].name);
    textout(screen, (FONT*)graphics[FONT_NORMAL].dat, text, 55, 80+i*20, 15);
    sprintf(text, "%06d", HighScores[i].score);
    textout(screen, (FONT*)graphics[FONT_NORMAL].dat, text, 380, 80+i*20, 15);
    sprintf(text, "%02d", HighScores[i].level);
    textout(screen, (FONT*)graphics[FONT_NORMAL].dat, text, 460, 80+i*20, 15);
  }
  show_mouse(screen);                                        // mostra o rato
}

/* +------------------------------------------- fim de DrawHighScores ---+ */

/* +-------------------------------------------------- ViewHighScores ---+
   | Verso   : I (1.00.00)                                              |
   | Funo   : Mostra os High Scores                                    |
   +---------------------------------------------------------------------+ */

void ViewHighScores(void)
{
  PlaySong();                                         // toca msica de fundo
  Button btn_high_scores = Button("E x i t", 100, 420, 300, 450, 28, 20, (BITMAP*)graphics[BTN_GAME].dat);
  Button btn_reset = Button("R e s e t", 340, 420, 540, 450, 28, 20, (BITMAP*)graphics[BTN_GAME].dat);
  DrawHighScores();                                        // desenha o cran
  btn_high_scores.DrawButton();                          // desenha os botes
  btn_reset.DrawButton();
  while (1==1) {
    if (btn_high_scores.Clicked())                                 // E x i t
      break;
    else
      if (btn_reset.Clicked()) {                                 // R e s e t
        for (int i = 0; i < MAX_HIGHSCORES; i++) {
          HighScores[i].score = 0;
          HighScores[i].level = 0;
          strcpy(HighScores[i].name, "Pac Boy");
        }
        DrawHighScores();                                  // desenha o cran
        btn_high_scores.DrawButton();                    // desenha os botes
        btn_reset.DrawButton();
      }
      else
        if (key[KEY_ESC])                             // tecla ESC -> E x i t
          break;
  }
  stop_midi();                                        // para msica de fundo
}

/* +------------------------------------------- fim de ViewHighScores ---+ */

/* +----------------------------------------------- DrawStartGameMenu ---+
   | Verso   : I (1.00.00)                                              |
   | Funo   : Desenha o menu                                           |
   +---------------------------------------------------------------------+ */

void DrawStartGameMenu(void)
{
  show_mouse(NULL);                                         // esconde o rato
  drawing_mode(DRAW_MODE_COPY_PATTERN, (BITMAP*)graphics[PATTERN2].dat, 0, 0);
  rectfill(screen, 0, 0, SCREEN_W, SCREEN_H, 1);
  solid_mode();
  text_mode(-1);
  rect(screen, 0, 0, SCREEN_W-1, SCREEN_H-1, 25);
  draw_sprite(screen, (BITMAP*)graphics[PAC_MAN_I].dat, 125, 25);
  show_mouse(screen);                                        // mostra o rato

  btn_start_game->DrawButton();
  btn_custom_game->DrawButton();
  btn_prev_menu->DrawButton();
  btn_high_scores->DrawButton();
  btn_credits->DrawButton();
  btn_options->DrawButton();
}

/* +---------------------------------------- fim de DrawStartGameMenu ---+ */

/* +--------------------------------------------------- StartGameMenu ---+
   | Verso   : I (1.00.00)                                              |
   | Funo   : Faz o menu do jogo (Start Game, Custom Game, etc)        |
   |             |-> Controla o menu do jogo                             |
   +---------------------------------------------------------------------+ */

void StartGameMenu(void)
{
  btn_start_game  = new Button("Start Game",    200, 140, 440, 170, 28, 20, (BITMAP*)graphics[BTN_GAME].dat);
  btn_custom_game = new Button("Custom Game",   200, 180, 440, 210, 28, 20, (BITMAP*)graphics[BTN_GAME].dat);
  btn_options     = new Button("Options",       200, 220, 440, 250, 28, 20, (BITMAP*)graphics[BTN_GAME].dat);
  btn_high_scores = new Button("High Scores",   200, 260, 440, 290, 28, 20, (BITMAP*)graphics[BTN_GAME].dat);
  btn_credits     = new Button("Credits",       200, 300, 440, 330, 28, 20, (BITMAP*)graphics[BTN_GAME].dat);
  btn_prev_menu   = new Button("Previous Menu", 200, 340, 440, 370, 28, 20, (BITMAP*)graphics[BTN_GAME].dat);

  show_mouse(NULL);                                         // esconde o rato
  fade_out(10);
  DrawStartGameMenu();                                      // desenha o menu
  show_mouse(NULL);                                         // esconde o rato
  fade_in((RGB*)graphics[PAL_EDIT].dat, 3);
  show_mouse(screen);                                        // mostra o rato

  PlaySong();                                         // toca msica de fundo
  while (1==1) {                                      
    if (btn_start_game->Clicked()) {                            // Start Game
      stop_midi();                                  // para a msica de fundo
      strcpy(text, "Map: 0");
      PlayGame();                                                  // jogar!!
      DrawStartGameMenu();                                  // desenha o menu
      PlaySong();                                     // toca msica de fundo
    }
    else
      if (btn_custom_game->Clicked()) {                        // Custom Game
         stop_midi();                               // para a msica de fundo
         PlayCustomGame();                                         // jogar!!
         DrawStartGameMenu();                               // desenha o menu
         PlaySong();                                  // toca msica de fundo
      }
      else
        if (btn_prev_menu->Clicked())                        // Previous Menu
          break;
        else
          if (btn_high_scores->Clicked()) {                    // High Scores
            stop_midi();                            // para a msica de fundo
            ViewHighScores();                      // mostra os "high scores"
            DrawStartGameMenu();                            // desenha o menu
            PlaySong();                               // toca msica de fundo
          }
          else
            if (btn_credits->Clicked()) {                          // Credits
              stop_midi();                          // para a msica de fundo
              ViewCredits();                            // mostra os crditos
              DrawStartGameMenu();                          // desenha o menu
              set_pallete((RGB*)graphics[PAL_EDIT].dat);
              PlaySong();                             // toca msica de fundo
            }
            else
              if (btn_options->Clicked()) {                        // Options
                stop_midi();                        // para a msica de fundo
                Options();                                          // Opes
                DrawStartGameMenu();                        // desenha o menu
                set_pallete((RGB*)graphics[PAL_EDIT].dat);
                PlaySong();                         // toca a msica de fundo
              }
    if (key[KEY_ESC])                           // tecla ESC -> Previous Menu
      break;
  }  
  stop_midi();                                      // para a msica de fundo
  delete btn_start_game;                                 // destri os botes
  delete btn_custom_game;
  delete btn_prev_menu;
  delete btn_high_scores;
  delete btn_credits;
  delete btn_options;
}

/* +-------------------------------------------- fim de StartGameMenu ---+ */


/* +-------------------------------------------------- fim de misc.cc ---+ */
