/* +- pacgame.h ------------------------------------------- PAC MAN I ---+
   | Verso   : I (1.00.00 - Novembro, 1998)                             |
   | Funo   : Contm todos os dados referentes ao jogo                 |
   +---------------------------------------------------------------------+
   | Verso   : I (1.00.00 - Novembro, 1998)                             |
   +---------------------------------------------------------------------+
   | Copyright (c) Sheer Software Development                            |
   | All Rights Reserved                                                 |
   +---------------------------------------------------------------------+ */

#ifndef _pacgame_h
#define _pacgame_h

                                                // declarao de header files
#include <stdio.h>
#include <allegro.h>                            // header file para a Allegro
#include <stdio.h>
#include <string.h>
//#include <dir.h>
#include <time.h>
#include "set0.h"                      // header files para os ficheiros .pm1
#include "set1.h"                                                      // ...
#include "set2.h"                                                      // ...
#include "set3.h"                                                      // ...
#include "set4.h"                                                      // ...
#include "set5.h"                                                      // ...
#include "set6.h"                                                      // ...
#include "set7.h"                                                      // ...
#include "pac.h"                                                       // ...
#include "pac2.h"                                                      // ...
#include "maps.h"                                                      // ...
#include "sounds.h"                                                    // ...


#define NUM_SETS        8       // nmero de tipos de grficos (ex: set0.pm1)

#define MAX_HIGHSCORES  15                     // nmero mximo de highscores
#define MAX_SONGS       8                  // nmero de midis (sons de fundo)
#define MAX_MAPS        30                        // nmero de mapas (nveis)

typedef unsigned char BYTE;
typedef short    int  INTEGER;

extern DATAFILE *set_graphics[NUM_SETS];                    // set0..NUM_SETS

extern BITMAP *screen_bitmap;                               // 640x480 bitmap
extern BITMAP *map_bitmap;

extern DATAFILE *graphics;
extern DATAFILE *sprites;
extern DATAFILE *mapData;
extern DATAFILE *sounds;

struct map_struct {                                    // estrutura dos mapas
  INTEGER eater_x, eater_y;                  // posio inicial dos fantasmas    
  INTEGER pac_x, pac_y;                         // posio inicial do PAC MAN
  INTEGER num_eaters, num_balls;
  INTEGER values[22][22];
  INTEGER scores[8];
};

class Button {                                       // classe para os botes
  private:                                            // declaraes privadas
    int x1, x2, y1, y2;
    int frame1, frame2;
    BITMAP *bitmap;
    char name[25];
    int pressed;
  public:                                             // declaraes pblicas
    Button(char *, int xa, int ya, int xb, int yb, int f1, int f2, BITMAP*);
    void DrawButton(void);
    bool Clicked(void);
    void ChangeName(char*);
};

                                                  // declarao de prottipos
void Error(char *string);
bool mouseinbox(int x1, int y1, int x2, int y2);
bool FileExist(char *filename);
void DrawFrame(int x1, int y1, int x2, int y2, int col1, int col2);
void main_edit(void);
void Dtextout_centre(BITMAP *s, FONT *f, char *str, int x1, int y1, int col1, int col2);
void Dtextout(BITMAP* s, FONT* f, char *str, int x1, int y1, int col1, int col2);
void PlayGame(void);
void PlayMap(struct map_struct *map);
void StartGameMenu(void);
void InitGameGraphics(void);
void ViewHighScores(void);
void PlayCustomGame(void);
int  Random(int);
void PlaySong(void);

extern map_struct map;
extern char text[256];

extern int lives;
extern int score;

struct HighScoresStruct {                         // estrutura dos highscores
  int score;                                               // total do record
  int level;                                                  // nvel mximo
  char name[14];                                           // nome do jogador
};

extern struct HighScoresStruct HighScores[MAX_HIGHSCORES];
extern int    current_map_played;

extern int sound_on;
extern int music_on;
extern int sound_volume;
extern int music_volume;
extern int dif_level;


#endif


/* +------------------------------------------------ fim de pacgame.h ---+ */
